USERADD(8)

NAME
useradd - add a user to the system

SYNOPSIS
[-D] [-b base-dir] [-e expiry-time] [-f inactive-secs] [-g gid/name/=uid] [-r low..high]
[-G secondary-group] [-b base-dir] [-c comment] [-d home-dir] [-e expiry-time] [-f inactive-secs] [-g gid/name/=uid] [-k skel-dir] [-m] [-o] [-p password] [-r low..high] [-s shell] [-u uid] [-v] user

DESCRIPTION
The useradd utility adds a user to the system, creating and populating a home directory if necessary. Any skeleton dot files will be provided for the new user if they exist in the /etc/skel directory. Default values for the base directory, the time of password expiry, the skeleton directory, seconds until password change, primary group, the range from which the uid will be allocated, and default login shell can be provided in the /etc/usermgmt.conf file.

The first format of the command shown above (utilising the -D option) sets and displays the defaults for the useradd utility.

-D  without any further options, -D will show the current defaults which will be used by the useradd utility. Together with one of the options shown for the first version of the command, -D will set the default to be the new value.

-b base-dir
    sets the base directory. This is the directory to which the user name is added, which will be created if the -m option is specified and no -d option is specified.

-e expiry-time
    sets the time at which the current password will expire for this user.

-f inactive-secs
    sets the number of seconds after which, if no login has occurred for the user during that time, the login will be "locked".

-g gid/groupname/=uid
    sets the default group for any user added using the useradd command.

-r low..high
    sets the low and high bounds of uid ranges for new users. A new user can only be created if there are uids which can be assigned from one of the free ranges.

In the second form of the command, after setting any defaults, and then values from that file, the command line options are processed:

-G secondary-group
    is the secondary group to which the user will be added in the /etc/group file.

-b base-directory
    is the base directory name, in which the user's new home directory will be created, should the -m option be specified. This value can be preset for all users by using the base_dir field in the /etc/usermgmt.conf file - it has the format: base_dir <path-to-base-dir>.

-c comment
    is the comment field (also, for historical reasons known as the GECOS field) which will be added for the user, and typically will include the username, and, perhaps, contact information for the user.

-d home-directory
    is the home directory which will be created and populated for the user, should the -m option be specified.

-e secs-to-expiry
    provides the number of seconds since the epoch (UTC) at which the current password change expire. This can be used to implement password aging. A value of 0 can be used to switch off this feature. The default value for this field is 0. See passwd(5) for more details. This value can be preset for all users by using the expire field in the /etc/usermgmt.conf file - it has the format: expire <secs-to-expiry>.

-g gid/name/=uid
    gives the group name or identifier to be used for the new user's primary group. If this is -g=uid, then a uid and gid will be picked which are both unique and the same, and a line added to /etc/group to describe the new group. This value can be preset for all users by using the gid field in the /etc/usermgmt.conf file - it has the format: group <groupname/groupid/=uid>.

-k skeleton directory
    gives the skeleton directory in which to find dot files with which to populate the new user's home directory.

-m  create a new home directory for the new user.

-o  allow the new user to have a uid which is already in use for another user.

-p password
    specifies an already-encrypted password for the new user. This password can then be changed by using the chpass(1) utility. This value can be preset for all users by using the password field in the /etc/usermgmt.conf file - it has the format: password <encrypted-password>.

-s shell
    specifies the login shell for the new user. This value can be preset for all users by using the shell field in the /etc/usermgmt.conf file - it has the format: shell <login-shell>.

-u uid
    specifies a uid for the new user. Boundaries for this value can be preset for all users by using the range field in the /etc/usermgmt.conf file - they have the format: range <starting-uid>..<ending-uid>.

-v  enables verbose mode - explain the commands as they are executed.

The useradd utility exits 0 on success, and >0 if an error occurs.

HISTORY
The useradd utility first appeared in NetBSD 1.5. It is based on the addnerd package by the same author.

AUTHOR
The useradd utility was written by Alistair G. Crooks (agc@netbsd.org).

SEE ALSO
chpass(1), passwd(5), group(5), user(8), userdel(8), usermod(8), /etc/usermgmt.conf, /etc/skel/.[A-z]*, /usr/share/examples/usermgmt